Unit de90e_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc, DE92ES_p, UTDE21_p;

procedure de90e(F :Proc_FE_DE; FJ :Proc_FE_DE; M :Integer;
                var JSTART :Integer; HMIN :Extended; EPS :Extended;
                P :Extended; var YX :Array of Extended; var X :Extended;
                var H :Extended; var BUL :Boolean; var XP :Extended;
                var YP :Array of Extended; var A :Array of Extended;
                var A1 :Array of Extended; var A2 :Array of Extended;
                var RAB :Array of Extended; var R1 :Array of Extended;
                var R2 :Array of Extended; var YD :Array of Extended;
                var IERR :Integer);

implementation

procedure de90e(F :Proc_FE_DE; FJ :Proc_FE_DE; M :Integer;
                var JSTART :Integer; HMIN :Extended; EPS :Extended;
                P :Extended; var YX :Array of Extended; var X :Extended;
                var H :Extended; var BUL :Boolean; var XP :Extended;
                var YP :Array of Extended; var A :Array of Extended;
                var A1 :Array of Extended; var A2 :Array of Extended;
                var RAB :Array of Extended; var R1 :Array of Extended;
                var R2 :Array of Extended; var YD :Array of Extended;
                var IERR :Integer);
var
I,I1,I2,I3 :Integer;
EPS1,HS,XT :Extended;
BULD,BULHM :Boolean;
label
_2,_3,_8,_18,_19,_80,_85,_100,_105,_106,_110,_130;
begin
{   BOHEHE OHOO AA  ABTOHOMHO CCTEM C KOHTPOEM }
{   TOHOCT O PABY PYHE C OOBATECKO OPOPAMMO }
{   BCEH MATP KO. }
IERR := 0;
BULD := True;
BULHM := False;
if ( JSTART ) < 0
 then goto _2
 else if ( JSTART ) > 0
       then goto _8
       else goto _8;
_2:
for I:=1 to M do
 begin
_3:
  YX[I-1] := YP[I-1];
 end;
X := XP;
_8:
EPS1 := EPS/32.e0;
I1 := 1 + M;
I2 := I1 + M;
I3 := I2 + M;
FJ (X,YX,A,M);
_18:
DE92ES (F,M,YX,X,A,H,R2,RAB[0],RAB[I1-1],RAB[I2-1],RAB[I3-1],A1);
_19:
HS := H;
H := H/2.e0;
DE92ES (F,M,YX,X,A,H,R1,RAB[0],RAB[I1-1],RAB[I2-1],RAB[I3-1],A1);
FJ (X+H,R1,A2,M);
DE92ES (F,M,R1,X+H,A2,H,YD,RAB[0],RAB[I1-1],RAB[I2-1],
     RAB[I3-1],A1);
H := HS;
for I:=1 to M do
 begin
  RAB[I-1] := (YD[I-1] - R2[I-1])/15.e0;
  XT := Abs(RAB[I-1]);
  if ( Abs(YD[I-1]) >= P ) 
   then XT := XT/Abs(YD[I-1]);
  if ( XT > EPS ) 
   then goto _100;
  if ( XT >= EPS1 ) 
   then BULD := False;
_80:
 end;
XP := X;
X := X + H;
for I:=1 to M do
 begin
  YP[I-1] := YX[I-1];
_85:
  YX[I-1] := YD[I-1];
 end;
if ( BULD ) 
 then H := H*2.e0;
goto _130;
_100:
if ( BULHM ) 
 then goto _110;
H := H/2.e0;
BUL := False;
if ( Abs(H) > Abs(HMIN) ) 
 then goto _105;
H := Sign(HMIN,H);
BULHM := True;
goto _18;
_105:
for I:=1 to M do
 begin
_106:
  R2[I-1] := R1[I-1];
 end;
goto _19;
_110:
IERR := 65;
UTDE21 (90,IERR);
_130:
JSTART := 1;
end;

end.
