Unit de92es_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc, AIG2E_p, DE92EK_p;

procedure de92es(F :Proc_FE_DE; M :Integer; var Y :Array of Extended;
                X :Extended; var A :Array of Extended; H :Extended;
                var R :Array of Extended; var R1 :Array of Extended;
                var R2 :Array of Extended; var R3 :Array of Extended;
                var R4 :Array of Extended; var B :Array of Extended);

implementation

procedure de92es(F :Proc_FE_DE; M :Integer; var Y :Array of Extended;
                X :Extended; var A :Array of Extended; H :Extended;
                var R :Array of Extended; var R1 :Array of Extended;
                var R2 :Array of Extended; var R3 :Array of Extended;
                var R4 :Array of Extended; var B :Array of Extended);
var
I,J :Integer;
IR1 :Array of Integer;
C :Array [0..7] of Extended;
label
_20,_10,_50,_60,_70,_80;
begin
{   DATA  FORTRAN  }
C[0] := 0.125e0;
C[1] := 0.375e0;
C[2] := 0.79166666666666666667e0;
C[3] := -0.16666666666666666667e0;
C[4] := 2.1666666666666666667e0;
C[5] := 0.16666666666666666667e0;
C[6] := -2.0e0;
C[7] := 0.66666666666666666667e0;
{      BOHEHE OHOO AA   A B T O H O M H O   CCTEM. }
for J:=1 to M do
 begin
  for I:=1 to M do
   begin
    B[(I-1)+(J-1)*M] := -H*A[(I-1)+(J-1)*M];
_20:
   end;
  B[(J-1)+(J-1)*M] := B[(J-1)+(J-1)*M] + 1.e0;
_10:
 end;
{ AIG2E (B,R1,M); }
{  18.02.2009   . }
{      IR1   R1  / AIG2E}
SetLength(IR1,2*M);
AIG2E (B,IR1,M);
F (X,Y,R1,M);
DE92EK (M,B,R1,H,R2);
for I:=1 to M do
 begin
_50:
  R1[I-1] := Y[I-1] - R2[I-1];
 end;
F (X,R1,R3,M);
DE92EK (M,B,R3,H,R1);
for I:=1 to M do
 begin
_60:
  R3[I-1] := Y[I-1] + C[0]*R2[I-1] + C[1]*R1[I-1];
 end;
F (X,R3,R4,M);
DE92EK (M,B,R4,H,R3);
for I:=1 to M do
 begin
_70:
  R4[I-1] := Y[I-1] + C[1]*R2[I-1] + C[2]*R1[I-1] + C[3]*R3[I-1];
 end;
F (X,R4,R,M);
DE92EK (M,B,R,H,R4);
for I:=1 to M do
 begin
_80:
  R[I-1] := Y[I-1] + C[4]*R2[I-1] + C[5]*R1[I-1] + C[6]*R3[I-1] +
    C[7]*R4[I-1];
 end;
end;

end.
